export interface IDisposable {
    dispose(): void;
}
export declare class CallbackList {
    private _callbacks;
    private _contexts;
    add(callback: Function, context?: any, bucket?: IDisposable[]): void;
    remove(callback: Function, context?: any): void;
    invoke(...args: any[]): any[];
    isEmpty(): boolean;
    dispose(): void;
}
export interface EmitterOptions {
    onFirstListenerAdd?: Function;
    onLastListenerRemove?: Function;
}
export declare class Emitter<T> {
    private _options;
    private static _noop;
    private _event;
    private _callbacks;
    constructor(_options?: EmitterOptions);
    /**
     * For the public to allow to subscribe
     * to events from this Emitter
     */
    event: Event<T>;
    /**
     * To be kept private to fire an event to
     * subscribers
     */
    fire(event: T): any;
    dispose(): void;
}
